//
// automatically generated by spin2cpp v1.92 on Tue Apr 21 11:27:35 2015
// spin2cpp --main --ccode HokeyPokey.spin 
//

// :::::::[ Driver Object for the Scribbler 2 ]:::::::::::::::::::::::::::::::::
/* {
┌───────────────────────────────────────┐
│          Scribbler S2 Object          │
│(c) Copyright 2010 Bueno Systems, Inc. │
│   See end of file for terms of use.   │
└───────────────────────────────────────┘
This object provides both high- and low-level drivers for the
Parallax Scribbler S2 robot.

Version History
───────────────

2010.09.16: Initial Version 1(M) release
2010.09.28: Version 1(N) release:
              Fixed bug in _ee* Spin routines.
              Upped size of sound buffer to 1200.
              Added calibration methods for light sensors.
              Added 1/2 sec. delay to start routine.
2010.10.18:   Added check for zero time in play_tone.
2010.10.25:   Added log response method for light sensors.
2010.10.27: Version 1(O) release:
              Added methods to save default line sensor threshold.
2010.10.28:   Fixed bugs in calibration methods.
2010.11.15: Version 1(P) release:
              Added self-documentation features.
              Added sensitivity setting for obstacle detection.
2010.11.24: Version 1(Q) release:
              Added sample programs to self-documentation.
 */
/* =======[ Introduction ]=========================================================

S2.spin provides low-level drivers for the S2 Robot's various functions, as well as
top-level access functions to interface with those drivers. Driver functions are
separated into four additional cogs:
''
''  1. Analog, button, and LED drivers.
''  2. Motor driver.
''  3. Sound sequencer and synthesizer.
''  4. Microphone envelope detector.
''
Driver #1 is required and is started with the S2 object's main `start method. The
other drivers are optional, depending upon the user's requirements, and have their
own start methods (`start_motors, `start_tones, `start_mic_env). The S2 object's
`stop method stops all driver cogs which have been started.

The analog, button, and LED drivers are the heartbeat of the system. The analog
driver continuously cycles through sixteen analog inputs and updates their states
with a one-millisecond cycle time. The button driver monitors the state
of the S2's single pushbutton and, depending on the user-selected button mode, can
cause it to reset the S2, while displaying the button-press count on the LEDs, and
record the number of button presses in EEPROM for use by the newly-restarted user
program. The LED driver manages the LEDs' polarity and PWMing to provide various
shades and hues from the S2's red/green LEDs and blue power LED. It does this via
the LEDs' shift register port.

 */
// =======[ Constants... ]=========================================================
#include <propeller.h>
#include "S2T.h"

#ifdef __GNUC__
#define INLINE__ static inline
#define Yield__() __asm__ volatile( "" ::: "memory" )
#define PostEffect__(X, Y) __extension__({ int32_t tmp__ = (X); (X) = (Y); tmp__; })
#else
#define INLINE__ static
static int32_t tmp__;
#define PostEffect__(X, Y) (tmp__ = (X), (X) = (Y), tmp__)
#define Yield__()
#define waitcnt(n) _waitcnt(n)
#define coginit(id, code, par) _coginit((unsigned)(par)>>2, (unsigned)(code)>>2, id)
#define cognew(code, par) coginit(0x8, (code), (par))
#define cogstop(i) _cogstop(i)
#endif

INLINE__ int32_t Min__(int32_t a, int32_t b) { return a < b ? a : b; }
INLINE__ int32_t Max__(int32_t a, int32_t b) { return a > b ? a : b; }
INLINE__ int32_t Shr__(uint32_t a, uint32_t b) { return (a>>b); }
static  int32_t S2T__enqueue_tone( S2T *self, int32_t tone_word);

static uint8_t dat[] = {
  0x8a, 0xf0, 0xbf, 0xa0, 0x89, 0x50, 0xbd, 0xa0, 0x95, 0x50, 0xbd, 0x80, 0x95, 0x50, 0xbd, 0x80, 
  0xa8, 0x2c, 0xbd, 0xa0, 0x02, 0x50, 0xfd, 0x80, 0xa8, 0x2e, 0xbd, 0xa0, 0x02, 0x50, 0xfd, 0x80, 
  0xa8, 0x30, 0xbd, 0xa0, 0x01, 0x50, 0xfd, 0x80, 0xa8, 0x32, 0xbd, 0xa0, 0xf1, 0x4b, 0xbd, 0xa0, 
  0x88, 0x4a, 0xbd, 0x80, 0x61, 0xf8, 0xfc, 0x5c, 0xa8, 0x4e, 0xbd, 0xa0, 0x8f, 0x50, 0xbd, 0x60, 
  0x0d, 0x4e, 0xfd, 0x2a, 0x1e, 0x00, 0x68, 0x5c, 0x01, 0x4e, 0x7d, 0x86, 0x17, 0x00, 0x54, 0x5c, 
  0x03, 0x50, 0xfd, 0x2c, 0xa8, 0x26, 0xbd, 0xa0, 0x0d, 0x00, 0x7c, 0x5c, 0x02, 0x4e, 0x7d, 0x86, 
  0x1c, 0x00, 0x68, 0x5c, 0x03, 0x4e, 0x7d, 0x86, 0x0d, 0x00, 0x54, 0x5c, 0x00, 0x28, 0xfd, 0xa0, 
  0x99, 0x50, 0x3d, 0x00, 0x0d, 0x00, 0x7c, 0x5c, 0xa8, 0x48, 0xbd, 0xa0, 0x06, 0x50, 0xfd, 0x2c, 
  0xa8, 0x48, 0xbd, 0x80, 0x01, 0x48, 0xfd, 0x28, 0x61, 0xf8, 0xfc, 0x5c, 0xa8, 0x3e, 0xbd, 0xa0, 
  0x12, 0x3e, 0xfd, 0x2e, 0x01, 0x3e, 0xfd, 0x28, 0x00, 0x38, 0xe9, 0xa0, 0xa8, 0x42, 0xbd, 0xa0, 
  0x0e, 0x42, 0xfd, 0x28, 0x61, 0xf8, 0xfc, 0x5c, 0xa8, 0x40, 0xbd, 0xa0, 0x12, 0x40, 0xfd, 0x2e, 
  0x01, 0x40, 0xfd, 0x28, 0x00, 0x3a, 0xe9, 0xa0, 0xa8, 0x44, 0xbd, 0xa0, 0x0e, 0x44, 0xfd, 0x28, 
  0x8b, 0xec, 0xbf, 0x68, 0x98, 0x50, 0xbd, 0x00, 0x01, 0x50, 0x7d, 0x86, 0x0d, 0x00, 0x68, 0x5c, 
  0x9f, 0x38, 0xbd, 0x80, 0xa0, 0x3a, 0xbd, 0x80, 0x9c, 0x3c, 0xbd, 0xa0, 0xa1, 0x46, 0xbd, 0xa0, 
  0x48, 0xc0, 0xfc, 0x5c, 0xa8, 0x4c, 0xbd, 0xa0, 0x9d, 0x3c, 0xbd, 0xa0, 0xa2, 0x46, 0xbd, 0xa0, 
  0x48, 0xc0, 0xfc, 0x5c, 0xa8, 0x4c, 0xbd, 0x80, 0xa6, 0x50, 0xbd, 0xa8, 0x93, 0x52, 0xbd, 0xa0, 
  0x7d, 0x0e, 0xfd, 0x5c, 0x01, 0x4c, 0xfd, 0x2d, 0x8d, 0x4c, 0xbd, 0xa0, 0xa8, 0x4c, 0xbd, 0x90, 
  0x88, 0x4a, 0xbd, 0xf8, 0xa6, 0xf4, 0xbf, 0xa0, 0x31, 0x48, 0xfd, 0xe4, 0x0d, 0x00, 0x7c, 0x5c, 
  0x02, 0x46, 0x7d, 0x61, 0x01, 0x46, 0x7d, 0x62, 0x53, 0x00, 0x70, 0x5c, 0x4f, 0x00, 0x54, 0x5c, 
  0x01, 0x3c, 0x7d, 0x2d, 0x8e, 0x50, 0xbd, 0xb0, 0x60, 0x00, 0x3c, 0x5c, 0x9e, 0x50, 0xbd, 0xa0, 
  0x8d, 0x50, 0xbd, 0x80, 0x01, 0x50, 0xfd, 0x38, 0x60, 0x00, 0x3c, 0x5c, 0x57, 0x00, 0x54, 0x5c, 
  0x9e, 0x50, 0xbd, 0xa8, 0x8e, 0x50, 0xbd, 0x84, 0x60, 0x00, 0x3c, 0x5c, 0x13, 0x3c, 0xfd, 0x28, 
  0x90, 0x3c, 0x3d, 0x62, 0x91, 0x3c, 0x3d, 0x61, 0x9e, 0x3c, 0xbd, 0xb0, 0x92, 0x3c, 0xbd, 0x68, 
  0x01, 0x3c, 0xfd, 0x2c, 0x9e, 0x50, 0xbd, 0x04, 0xa8, 0x50, 0xbd, 0xbc, 0x0e, 0x50, 0xfd, 0x2c, 
  0x00, 0x00, 0x7c, 0x5c, 0x98, 0x50, 0xbd, 0x00, 0x02, 0x50, 0x7d, 0x86, 0x01, 0x50, 0x55, 0x86, 
  0x00, 0x28, 0xe9, 0xa0, 0x68, 0x00, 0x68, 0x5c, 0x03, 0x50, 0x7d, 0x86, 0x01, 0x28, 0xe9, 0xa0, 
  0x98, 0x18, 0x29, 0x00, 0x94, 0x28, 0x3d, 0x62, 0x6f, 0x00, 0x68, 0x5c, 0x96, 0x34, 0xbd, 0x04, 
  0x97, 0x36, 0xbd, 0x04, 0x9b, 0x34, 0x3d, 0x86, 0x74, 0x00, 0x54, 0x5c, 0xff, 0xf5, 0xff, 0xe1, 
  0x8b, 0xec, 0x8f, 0x64, 0xf1, 0x4b, 0xbd, 0xa0, 0x88, 0x4a, 0xbd, 0x80, 0x61, 0x00, 0x7c, 0x5c, 
  0x01, 0x36, 0xfd, 0x2c, 0x89, 0x36, 0xbd, 0x80, 0x9b, 0x50, 0xbd, 0x04, 0x89, 0x36, 0xbd, 0x84, 
  0x01, 0x36, 0xfd, 0x28, 0x01, 0x36, 0xfd, 0x80, 0x95, 0x36, 0xbd, 0xe0, 0x97, 0x36, 0x3d, 0x04, 
  0x00, 0x00, 0x7c, 0x5c, 0x00, 0x54, 0xfd, 0xa0, 0x20, 0x56, 0xfd, 0xa0, 0x01, 0x50, 0xfd, 0x29, 
  0xa9, 0x54, 0xb1, 0x81, 0x01, 0x54, 0xfd, 0x31, 0x01, 0x50, 0xfd, 0x31, 0x80, 0x56, 0xfd, 0xe4, 
  0x10, 0x50, 0xfd, 0x28, 0x10, 0x54, 0xfd, 0x2c, 0xaa, 0x50, 0xbd, 0x68, 0x00, 0x00, 0x7c, 0x5c, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x15, 0x00, 0x00, 0x18, 0x00, 0x00, 0x20, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xff, 0xff, 0xff, 0x3f, 0xff, 0x1f, 0x00, 0x00, 
  0x00, 0x10, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x70, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0xb0, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0xbb, 0x03, 0x99, 0x00, 0xdd, 0x01, 0xee, 0x00, 0x1e, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 
  0x14, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 
};
// =======[ Public Spin methods... ]===============================================
int32_t S2T_start_tones(S2T *self)
{
  int32_t result = 0;
  /*  This method starts the tone (sound) sequencer and synthesizer. It must
       be called before any sound methods are invoked.
    ''
    '' `Example: s2.start_tones
    ''
    ''     Start the tone sequencer/generator.
    
   */
  if (!(((uint8_t *)&dat[3178])[0])) {
    memset( (void *)&(*(uint16_t *)&dat[768]), 0, sizeof(uint16_t)*(_TONE_Q_SIZE + 4));
    ((int32_t *)&dat[544])[0] = (CLKFREQ / 65536) * 2;
    ((int32_t *)&dat[548])[0] = (int32_t)(&(*(uint16_t *)&dat[768]));
    result = -((((uint8_t *)&dat[3178])[0] = cognew((int32_t)(&(*(int32_t *)&dat[0])), 0) + 1) > 0);
    S2T_command_tone(self, PLAY);
  }
  return result;
}

/*      
PUB start_mic_env

  {{ This method starts the microphone envelope detector. It is used mainly for
     testing at the factory, but it could possibly be used to detect loud noises
     such as claps, for example. It must be started before calling any microphone
     envelope methods.
  ''
  '' `Example: s2.start_mic_env
  ''
  ''     Start the microphone Envelope detector.
  }}

  ifnot (Mic_cog)
    mic_dt := clkfreq / 8000
    mic_cyc := 8000 / 20
    return (Mic_cog := cognew(@env_det, @Envelope) + 1) > 0
 */
int32_t S2T_stop_all(S2T *self)
{
  /*  This method is used to stop all S2 cogs that have been started with the other
       start methods. It is called by `start, but its use is otherwise limited.
    ''
    '' `Example: s2.stop_all
    ''
    ''     Stop all S2 cogs.
    
   */
  /* 
    if (Adc_cog)
      cogstop(Adc_cog~ - 1)
   */
  if ((*(uint8_t *)&dat[3178])) {
    cogstop((PostEffect__((*(uint8_t *)&dat[3178]), 0) - 1));
  }
  return 0;
}

/*     
  if (Mic_cog)
    cogstop(Mic_cog~ - 1)
  if (Motor_cog)
    cogstop(Motor_cog~ - 1)
 */
// -------[ Sound methods... ]--------------------------------------------------
/*  The S2 sound sequencer and synthesizer is capable of queueing and producing
   biphonic sound in four different voices: square-, triangle-, sawtooth-, and
   sine-waves. Each "note" has two pitches, two voices, and duration information
   encoded within it. Speaker volume is adjustable over a 0 to 100 range.
   There is also a synchronizing capability, so that other robot
   actions can be choreographed to the sounds produced.
 */
int32_t S2T_beep(S2T *self)
{
  /*  Set volume level to 50%, and send a 150ms 1 KHz tone, followed by a 350ms pause.
    ''
    '' `Example: s2.beep
    ''
    ''     Make the speaker beep.
    
   */
  S2T_set_volume(self, 50);
  S2T_set_voices(self, SIN, SIN);
  S2T_play_tone(self, 150, 1000, 0);
  return S2T_play_tone(self, 350, 0, 0);
}

int32_t S2T_command_tone(S2T *self, int32_t cmd_tone)
{
  /*  Send an immediate command to the sound generator:
  ''
  ''     'cmd_tone: One of the following:
  ''
  ''        `STOP:  Stops sound production immediately, then clears the sound queue.
  ''        `PAUSE: Pauses sound production after the note currently being played.
  ''        `PLAY:  Resumes sound production from the queue.
  ''
  '' `Example: s2.command_tone(STOP)
  ''
  ''     Cause sounds to cease immediately.
   */
  if (cmd_tone == STOP || cmd_tone == PAUSE || cmd_tone == PLAY) {
    ((uint8_t *)&dat[3172])[0] = cmd_tone;
    while ((*(uint8_t *)&dat[3172])) {
      Yield__();
    }
    if (cmd_tone == STOP) {
      ((uint16_t *)&dat[3168])[0] = (*(uint16_t *)&dat[3170]);
    }
  }
  return 0;
}

int32_t S2T_set_volume(S2T *self, int32_t vol)
{
  /*  Set the speaker volume level for the notes to follow
    ''
    ''     `vol (0 - 100): the selected volume level.
    ''
    '' `Example: s2.set_volume(50)
    ''
    ''     Set volume level to 50%.
    
   */
  return S2T__enqueue_tone(self, (0x2000 | (((Min__((Max__(vol, 0)), 100)) * 8191) / 100)));
}

int32_t S2T_set_voices(S2T *self, int32_t v1, int32_t v2)
{
  /*  Set the voice for each channel for the notes to follow.
    ''
    ''     `v1, `v2 (SQU, SAW, TRI, SIN): Value for each voice, square-, sawtooth-, triangle-, or sine-wave.
    ''
    '' `Example: s2.set_voices(s2#SIN, s2#TRI)
    ''
    ''     Set voice 1 to sine wave; voice 2 to triangle wave.
    
   */
  ((uint8_t *)&dat[3174])[0] = v1 & 0x3;
  ((uint8_t *)&dat[3175])[0] = v2 & 0x3;
  return 0;
}

int32_t S2T_play_sync(S2T *self, int32_t value)
{
  /*  Insert a SYNC command into the sound queue.
       When the sound processor encounters it during playback, it writes the value
       to the hub variable `Tone_sync, then continues. This method can be used to
       synchronize motion to the sound being played.
    ''
    ''     `value (1 - 255): the value to insert into the queue.
    ''
    '' `Example: s2.play_sync(12)
    ''
    ''     Insert a `SYNC 12 into the sound queue. When encountered during playback,
    ''     the player will set the sync value to 12 (for `get_sync) and continue
    ''     with the next command.
    
   */
  return S2T__enqueue_tone(self, (0x4000 | (value & 0xff)));
}

int32_t S2T_play_pause(S2T *self, int32_t value)
{
  /*  Insert a PAUS command into the sound queue.
       When the sound processor encounters it during playback, it writes the value
    '' to the the hub variable Tone_sync, then pauses.
    ''
    ''     `value (1 - 255): the value to insert into the queue.
    ''
    '' `Example: s2.play_pause(12)
    ''
    ''     Insert a PAUS 12 into the tone queue. When encountered during playback,
    ''     the player will set the sync value to 12 (for `get_sync) and wait for a
    ''     PLAY command to resume.
    
   */
  return S2T__enqueue_tone(self, (0x6000 | (value & 0xff)));
}

int32_t S2T_get_sync(S2T *self)
{
  int32_t result = 0;
  /*  Get the current Tone_sync value.
    ''
    '' `Example: current_sync := s2.get_sync
    ''
    ''     Set `current_sync to the latest sync value written from the sound queue
    ''     while playing, then zero the sunc value if it was non-zero.
    
   */
  if ((result = (*(uint8_t *)&dat[3173]))) {
    ((uint8_t *)&dat[3173])[0] = 0;
  }
  return result;
}

int32_t S2T_wait_sync(S2T *self, int32_t value)
{
  /*  Wait for a particular sync value to be echoed from the sound queue during playback to echo
    '' or for the sound queue to become empty.
    ''
    ''     `value (0 - 255): If zero, wait for the queue to empty (i.e. for playback to stop;
    ''          otherwise, wait for the chosen sync value to be echoed.
    ''
    '' `Example: s2.wait_sync(12)
    ''
    ''     Wait until a sync value of 12 is returned from the tone queue.
    ''
       `Note: if `value is non-zero and no such SYNC value exists in the tone queue, this
       method will wait forever.
    
   */
  if ((*(uint8_t *)&dat[3178])) {
    if (value) {
      while (!(((uint8_t *)&dat[3173])[0] == value)) {
        Yield__();
      }
    } else {
      while (!(((uint16_t *)&dat[3170])[0] == ((uint16_t *)&dat[3168])[0])) {
        Yield__();
      }
    }
  }
  return 0;
}

int32_t S2T_play_tone(S2T *self, int32_t time, int32_t frq1, int32_t frq2)
{
  /*  Queue a sound for immediate playback with a given duration, mixing up to two frequencies,
       using the current voice and volume settings.
    ''
    ''     `time (1 - 8191): The duration (milliseconds) of the tone(s).
    ''
    ''     `frq1, `frq2 (0 - 10000): The frequency (Hz) of each voice. (Zero == silence.)
    ''
    '' `Example: s2.play_tone(1000, 440, 880)
    ''
    ''     Play an A440 and A880 for 1000 milliseconds.
    
   */
  if (!(time)) {
    return 0;
  }
  S2T__enqueue_tone(self, (time & 0x1fff));
  S2T__enqueue_tone(self, (((*(uint8_t *)&dat[3174]) << 14) | (frq1 & 0x3fff)));
  return S2T__enqueue_tone(self, (((*(uint8_t *)&dat[3175]) << 14) | (frq2 & 0x3fff)));
}

int32_t S2T_play_tones(S2T *self, int32_t addr)
{
  int32_t result = 0;
  /*  Add a command sequence to the tone queue.
    ''
    ''     'addr: The hub address of the command sequence to add, ending with a zero word.
    ''
    '' Commands are words in the following format:
    ''
    ''' 15  13 12                      0
    ''' ┌─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┐
    ''' │ Cmd │          Data           │
    ''' └─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┘
    ''
    '' Cmd: %000
    ''
    ''   Play tone for duration Data (0 - 8192ms),using the following `two words as
    ''   the voices, each having the following format:
    ''
    '''    15 14 13                        0
    '''     ┌─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┐
    '''     │Voc│         Frequency         │
    '''     └─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┘
    ''
    ''      Voc (voice):
    ''
    ''        00 = square wave
    ''        01 = sawtooth wave
    ''        10 = triangle wave
    ''        11 = sine wave
    ''
    ''     Frequency : 0 (no sound) to 16363 Hz.
    ''
    '' Cmd: %001
    ''
    ''   Set volume to Data << 3 (0 - 99.98% of full volume)
    ''
    '' Cmd: %010
    ''
    ''   Set sync to Data & $ff
    ''
    '' Cmd: %011
    ''
    ''   Set sync to Data & $ff, then PAUSE.
    ''
    '' `Example: s2.play_tones(@tone_buffer)
    ''
    ''     Add tones from tone_buffer (word array) to tone queue until a zero word is encountered.
    
   */
  while (((uint16_t *)addr)[0]) {
    result = S2T__enqueue_tone(self, ((uint16_t *)addr)[0]);
    addr = addr + 2;
  }
  return result;
}

// -------[ Time methods... ]---------------------------------------------------
/*  Time methods control and sense the S2's built-in millisecond timers and provide
   a convenient delay function.
 */
int32_t S2T_start_timer(S2T *self, int32_t number)
{
  /*  Start a 1 KHz count-up timer number, which counts up from zero
       by one every millisecond.
    ''
    ''     `number (0 - 7): The number ID of the timer to start.
    ''
    '' `Example: s2.start_timer(4)
    ''
    ''     Restarts timer number four from zero.
    
   */
  if ((number >= 0) && (number < 8)) {
    ((int32_t *)&dat[604])[number] = ((int32_t *)((*(int32_t *)&dat[600]) + 0xa))[0];
  }
  return 0;
}

int32_t S2T_get_timer(S2T *self, int32_t number)
{
  /*  Return the time (in milliseconds, up to 2 million seconds ~ 24 days) from the selected 1 KHz count-up timer.
    ''
    ''     `number: If 0 - 7, return the value of the selected timer;
    ''          otherwise, return the value of the master timer, which starts at 0 when the
    ''          Propeller is reset.
    ''
    '' `Example: elapsed_time := s2.get_timer(4)
    ''
    ''     Set `elapsed_time to the number of milliseconds elapsed since the Propeller reset
    ''          or timer #4 restart, whichever occurred last.
    
   */
  return (((int32_t *)((*(int32_t *)&dat[600]) + 0x28))[0] - (((int32_t *)&dat[604])[number] & -(-(number >= 0) && -(number < 8))));
}

int32_t S2T_delay_tenths(S2T *self, int32_t time)
{
  int32_t	time0;
  /*  Time delay in tenths of a second.
    ''
    ''     `tenths: Number of tenths of a second to delay before returning.
    ''
    '' `Example: s2.delay_tenths(20)
    ''
    ''     Wait a couple seconds.
    
   */
  time0 = CNT;
  {
    int32_t _idx__0007;
    int32_t _limit__0008 = time;
    for(_idx__0007 = 1; _idx__0007 <= _limit__0008; _idx__0007 = _idx__0007 + 1) {
      waitcnt((time0 = time0 + (CLKFREQ / 10)));
    }
  }
  return 0;
}

static int32_t S2T__enqueue_tone(S2T *self, int32_t tone_word)
{
  int32_t	next_ptr;
  /*  Wait for tone queue to become non-full, then add tone_word to it.  */
  if ((*(uint8_t *)&dat[3178])) {
    next_ptr = (*(uint16_t *)&dat[3168]) + 1;
    next_ptr = next_ptr & -(next_ptr < _TONE_Q_SIZE);
    while (!(((uint16_t *)&dat[3170])[0] != next_ptr)) {
      Yield__();
    }
    ((uint16_t *)&dat[768])[(*(uint16_t *)&dat[3168])] = tone_word;
    ((uint16_t *)&dat[3168])[0] = next_ptr;
    return (((*(uint16_t *)&dat[3168]) << 16) | (*(uint16_t *)&dat[3170]));
  }
  return 0;
}

// Current velocity.
// =======[ Sample Programs... ]================================================
/*  These sample programs can be copied and pasted into the Propeller Tool in order
   to try out the S2 object. To copy a sample program to try, click its `SOURCE `CODE...
   tag, then click anywhere within the source to select it, followed by Ctrl-C to copy
   it to the clipboard. It can then be pasted into the Propeller Tool.
 */
// -------[ Draw a Star ]-------------------------------------------------------
/*  This program will draw a five-pointed star with the S2 robot. */
/* {...
CON

  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000

OBJ

  s2 : "s2"

PUB start

  s2.start                       'Start the S2 object
  s2.start_motors                'Start the motor cog.
  s2.button_mode(true, true)     'Set button mode to display in LEDs and to reset.
  s2.set_led(s2#POWER, s2#BLUE)  'Turn on the power LED.
  s2.default_wheel_calibration   'Use the default wheel calibration (or change if needed).
  if (s2.reset_button_count)     'Do only if reset was via a button, rather than powerup.
    s2.here_is(0, 125)           'Start on top left point.
    s2.begin_path                'Begin a smooth drawing path.
    s2.move_to(200, 125)         'Move to top right point.
    s2.move_to(40, 0)            'Move to bottom left point.
    s2.move_to(100, 200)         'Move to tip-top point.
    s2.move_to(170, 0)           'Move to bottom right point.
    s2.move_to(0, 125)           'Finish at top left point.
    s2.end_path                  'End the drawing path. 
 */
// -------[ LED Microphone Monitor ]--------------------------------------------
/*  This program uses the LEDs as a bar graph to show the instantaneous microphone level.  */
/* {...
CON

  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000

OBJ

  s2 : "s2"

PUB start | volume

  s2.start                                                        'Start the S2 object.
  s2.start_mic_env                                                'Start the mic envelope detector.
  s2.set_led(s2#POWER, s2#BLUE)                                   'Turn on the power LED.
  repeat
    volume := ((s2.get_mic_env - $7_0000) * 6) ~> 17 #> 0 <# 59   'Get and scale the microphone volume.
    if (volume < 16)                                              'Is volume < 16?
      s2.set_leds(volume, 0, 0, s2#NO_CHANGE)                     '  Yes: Set LEFT LED to volume level.
    elseif (volume < 31)                                          'If not, is volume < 31?
      s2.set_leds(15, volume - 15, 0, s2#NO_CHANGE)               '  Yes: Turn on left LED; set center to difference.
    elseif (volume < 46)                                          'If not, is volume < 46?
      s2.set_leds(15, 15, volume - 30, s2#NO_CHANGE)              '  Yes: Turn on left and center LEDs; right to difference.
    else                                                          'Otherwise, overflow:
      s2.set_leds(15, 15, (volume - 45) << 4 | 15 - (volume - 45), s2#NO_CHANGE) 'Left and center on; right fading into red.
 */
// -------[ Obstacle Sensor Sounds ]--------------------------------------------
/*  This program uses the obstacle sensors to compute distance-dependent values,
   which are then converted to tones from the speaker. 
 */
/* {...
CON

   _clkmode       = xtal1 + pll16x
   _xinfreq       = 5_000_000

OBJ

  s2    : "s2"

PUB  Start | x, y

  s2.start                                          'Start the S2 object.
  s2.start_tones                                    'Start the tone generator.
  repeat                                            'Repeat forever...
    x := distance(s2#LEFT)                          'Get left and right obstacle "distances".
    y := distance(s2#RIGHT)                         
    s2.wait_sync(0)                                 'Wait for previous tone to finish playing.
    s2.play_tone(50, (99 - x) * 10, (99 - y) * 20)  'Play two tones, based on distance reading.

PUB distance(side) : x | dx, sum                    'Compute obstacle distance.

  x := 64                                           'Set x to middle value.
  dx := 32                                          'Set dx to half that.
  repeat while dx                                   'Do a binary search.
    sum~
    repeat 3                                        'Use best two out of three readings
      sum -= s2.obstacle(side, x)                   '  to determine proximity at this threshold setting.
    if (sum => 2)                                   'Detected?
      x += dx                                       '  Yes: Set threshold higher.
    else
      x -= dx                                       '  No:  Set threshold lower.
    dx >>= 1                                        'Cut increment in half.
  x := 100 - (x <# 100)                             'Invert threshold to obtain distance.
 */
// =======[ License ]===========================================================
/* {
┌──────────────────────────────────────────────────────────────────────────────────────┐
│                            TERMS OF USE: MIT License                                 │                                                            
├──────────────────────────────────────────────────────────────────────────────────────┤
│Permission is hereby granted, free of charge, to any person obtaining a copy of this  │
│software and associated documentation files (the "Software"), to deal in the Software │
│without restriction, including without limitation the rights to use, copy, modify,    │
│merge, publish, distribute, sublicense, and/or sell copies of the Software, and to    │
│permit persons to whom the Software is furnished to do so, subject to the following   │
│conditions:                                                                           │
│                                                                                      │
│The above copyright notice and this permission notice shall be included in all copies │
│or substantial portions of the Software.                                              │
│                                                                                      │
│THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,   │
│INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A         │
│PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT    │
│HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF  │
│CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE  │
│OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                                         │
└──────────────────────────────────────────────────────────────────────────────────────┘
 */
