//
// automatically generated by spin2cpp v1.92 on Tue Apr 21 11:27:35 2015
// spin2cpp --main --ccode HokeyPokey.spin 
//

#ifndef S2T_Class_Defined__
#define S2T_Class_Defined__

#include <stdint.h>

// -[ Version, etc. ]-
/*  Version numbers and miscellaneous other constants.  */
// Major version ID.
#define VERSION (1)
// Minor version ID.
#define SUBVERSION ('Q')
// Sets the size of the sound buffer (words).
#define _TONE_Q_SIZE (1200)
#define NO_CHANGE ((-1))
#define FOREVER (2147483647)
#define UNDEF ((int32_t)0x80000000U)
#define ACK (-1)
#define NAK (0)
// obstacle sensors, and wheels.
// -[ Button and LEDs ]-
/*  The button constants are used internally for setting and testing button modes.
     The LED constants can be used for turning the LEDs on and off and for setting intensity, blinking, and colors. 
 */
// Button constants:
// Bit selector for button reset enable.
#define RST_ENA (2)
// Bit selector for button reset LED indicator enable.
#define LED_ENA (1)
// LED constants: 
// Applies to all LEDs.
#define OFF (0)
// Apply to red/green LEDs only...
#define RED (240)
#define ORANGE (180)
#define YELLOW (120)
#define CHARTREUSE (75)
#define GREEN (15)
#define DIM_RED (112)
#define DIM_GREEN (7)
#define BLINK_RED (241)
#define BLINK_GREEN (31)
#define ALT_RED_GREEN (255)
// Apply to power LED only...
#define BLUE (240)
#define BLINK_BLUE (241)
#define DIM_BLUE (112)
// -[ Result array indices ]-
/*  These constants can be used to reference the various values in the Results array.  */
#define ADC_VSS (0)
#define ADC_VDD (1)
#define ADC_5V (2)
#define ADC_5V_DIV (3)
#define ADC_VBAT (4)
#define ADC_VTRIP (5)
#define ADC_IDD (6)
#define ADC_RIGHT_LGT (7)
#define ADC_CENTER_LGT (8)
#define ADC_LEFT_LGT (9)
#define ADC_RIGHT_LIN (10)
#define ADC_LEFT_LIN (11)
#define ADC_P6 (12)
#define ADC_P7 (13)
#define ADC_IMOT (14)
#define ADC_IDLER (15)
#define CNT_IDLER (16)
// and 19
#define LED_BYTES (18)
// and 21
#define TIMER (20)
#define BUTTON_CNT (22)
// -[ Propeller pins ]-
/*  Port names for pins A0 through A31.  */
// Hacker ports 0 - 5.
#define P0 (0)
#define P1 (1)
#define P2 (2)
#define P3 (3)
#define P4 (4)
#define P5 (5)
// Output to left obstacle IRED.
#define OBS_TX_LEFT (6)
// Output to LED shift register data pin.
#define LED_DATA (7)
// Output to LED shift register clock pin.
#define LED_CLK (8)
// Output (feedback) for microphone sigma-delta ADC.
#define MIC_ADC_OUT (9)
// Input for microphone sigma-delta ADC.
#define MIC_ADC_IN (10)
// Input for pushbutton.
#define BUTTON (11)
// Output to idler wheel encoder IRED.
#define IDLER_TX (12)
// Input from left motor encoder.
#define MOT_LEFT_ENC (13)
// Input from right motor encoder.
#define MOT_RIGHT_ENC (14)
// Output to right obstacle IRED.
#define OBS_TX_RIGHT (15)
// Output to left motor controller direction pin.
#define MOT_LEFT_DIR (16)
// Output to right motor controller direction pin.
#define MOT_RIGHT_DIR (17)
// Output to left motor controller PWM pin.
#define MOT_LEFT_PWM (18)
// Output to right motor controller PWM pin.
#define MOT_RIGHT_PWM (19)
// Input from obstacle detector IR receiver.
#define OBS_RX (20)
// Output to speaker amplifier.
#define SPEAKER (21)
// Outputs to analog multiplexer address pins.
#define MUX0 (22)
#define MUX1 (23)
#define MUX2 (24)
#define MUX3 (25)
// Output (feedback) from main sigma-delta ADC.
#define _MUX_ADC_OUT (26)
// Input to main sigma-delta ADC.
#define _MUX_ADC_IN (27)
// Output clock to EEPROMs.
#define SCL (28)
// Input/Output data from/to EEPROMs.
#define SDA (29)
// Output to RS232.
#define TX (30)
// Input from RS232.
#define RX (31)
// -[ ADC constants ]-
/* These constants pertain to the main sigma-delta analog-to-digital converter. */
// These are the analog multiplexer addresses controlled by pins MUX0 through MUX3.
// Motor current.
#define _MUX_IMOT (0)
// Motor overcurrent threshold.
#define _MUX_VTRIP (1)
// Battery voltage.
#define _MUX_VBAT (2)
// Idler encoder response.
#define _MUX_IDLER (3)
// Vss reference (used for ADC self-calibration).
#define _MUX_VSS (4)
// +2.5V reference(used to measure +5V vs. Vdd).               
#define _MUX_5V_DIV (5)
// +5V reference (used for ADC self-calibration).
#define _MUX_5V (6)
// +3.3V reference (used for ADC self-calibration.)
#define _MUX_VDD (7)
// Hacker port P7 analog input.
#define _MUX_P7 (8)
// Right light sensor.
#define _MUX_RIGHT_LGT (9)
// Center light sensor.
#define _MUX_CENTER_LGT (10)
// Hacker port P6 analog input.
#define _MUX_P6 (11)
// Vdd current.
#define _MUX_IDD (12)
// Left light sensor.
#define _MUX_LEFT_LGT (13)
// Right line sensor.
#define _MUX_RIGHT_LIN (14)
// Left line sensor.
#define _MUX_LEFT_LIN (15)
// These values are used by the ADC sequencer to retrieve analog values and store them
// in their respective array positions.
#define _VSS (((_MUX_VSS << 12) | (ADC_VSS << 8)))
#define _VDD (((_MUX_VDD << 12) | (ADC_VDD << 8)))
#define _5V (((_MUX_5V << 12) | (ADC_5V << 8)))
#define _5V_DIV (((_MUX_5V_DIV << 12) | (ADC_5V_DIV << 8)))
#define _VBAT (((_MUX_VBAT << 12) | (ADC_VBAT << 8)))
#define _IDD (((_MUX_IDD << 12) | (ADC_IDD << 8)))
#define _IMOT (((_MUX_IMOT << 12) | (ADC_IMOT << 8)))
#define _VTRIP (((_MUX_VTRIP << 12) | (ADC_VTRIP << 8)))
#define _IDLER (((_MUX_IDLER << 12) | (ADC_IDLER << 8)))
#define _RIGHT_LGT (((_MUX_RIGHT_LGT << 12) | (ADC_RIGHT_LGT << 8)))
#define _LEFT_LGT (((_MUX_LEFT_LGT << 12) | (ADC_LEFT_LGT << 8)))
#define _CENTER_LGT (((_MUX_CENTER_LGT << 12) | (ADC_CENTER_LGT << 8)))
#define _RIGHT_LIN (((_MUX_RIGHT_LIN << 12) | (ADC_RIGHT_LIN << 8)))
#define _LEFT_LIN (((_MUX_LEFT_LIN << 12) | (ADC_LEFT_LIN << 8)))
#define _P6 (((_MUX_P6 << 12) | (ADC_P6 << 8)))
#define _P7 (((_MUX_P7 << 12) | (ADC_P7 << 8)))
// These values are used in the ADC task list to define the precharge time before
// a conversion begins.
#define _SOAK_1us ((0 << 4))
#define _SOAK_2us ((1 << 4))
#define _SOAK_4us ((2 << 4))
#define _SOAK_8us ((3 << 4))
#define _SOAK_16us ((4 << 4))
#define _SOAK_32us ((5 << 4))
#define _SOAK_64us ((6 << 4))
#define _SOAK_128us ((7 << 4))
#define _SOAK_256us ((8 << 4))
#define _SOAK_512us ((9 << 4))
#define _SOAK_1ms ((10 << 4))
#define _SOAK_2ms ((11 << 4))
#define _SOAK_4ms ((12 << 4))
#define _SOAK_8ms ((13 << 4))
#define _SOAK_16ms ((14 << 4))
#define _SOAK_32ms ((15 << 4))
// These values are used in the ADC task list to define low-pass filtering time constants.
#define _LPF_NONE ((0 << 1))
#define _LPF_1ms ((1 << 1))
#define _LPF_2ms ((2 << 1))
#define _LPF_4ms ((3 << 1))
#define _LPF_8ms ((4 << 1))
#define _LPF_16ms ((5 << 1))
#define _LPF_32ms ((6 << 1))
#define _LPF_64ms ((7 << 1))
// These values are used in the ADC task list to define the reference voltage for each reading.
#define _REF_3V3 (0)
#define _REF_5V0 (1)
// -[ EEPROM addresses ]-
/*  These are address pointers into the auxiliary EEPROM, used for storing calibration data,
     button-press counts, and user data. 
 */
// Base address for EEPROM data area.
#define EE_BASE (0)
// [1 byte]  Reset count address.
#define EE_RESET_CNT ((EE_BASE + 0))
// [5 bytes] Wheel calibration data.
#define EE_WHEEL_CALIB ((EE_BASE + 1))
// [4 bytes] Light sensor calibration data.
#define EE_LIGHT_CALIB ((EE_BASE + 6))
// [2 bytes] Line sensor threshold data.
#define EE_LINE_THLD ((EE_BASE + 10))
// [2 bytes] Obstacle threshold data.
#define EE_OBSTACLE_THLD ((EE_BASE + 12))
// Beginning of unreserved user area.
#define EE_USER_AREA ((EE_BASE + 1024))
// -[ Default values ]-
/*  These values are assigned to their respective variables on startup, unless overriding values are stored
     in EEPROM. 
 */
#define DEFAULT_FULL_CIRCLE (955)
#define DEFAULT_WHEEL_SPACE (153)
#define DEFAULT_LIGHT_SCALE (0)
#define DEFAULT_LINE_THLD (32)
#define DEFAULT_OBSTACLE_THLD (20)
// -[ Motor constants ]-
/*  Command, status bits, and indices into the motor debug array.  */
// Command bits:
// Sets immediate (preemptive) mode for motor command.
#define MOT_IMM (1)
// Sets continuous (non-distance) mode for motor command.
#define MOT_CONT (2)
// Sets timeout mode for motor command.
#define MOT_TIMED (4)
// Status bits:
#define MOT_RUNNING (1)
#define MOT_STOPPED (0)
// Debug indices:
// These are indices into the motor debug array.
// Offsets are in bytes counting from @Motor_stat.
// The prefix indicates size of each value (Byte, Word, Long)
// All four control velocities.                                   
#define L_ALL_VEL (4)
// Target velocity.                        
#define B_TARG_VEL (4)
// Current (measured) velocity.
#define B_CUR_VEL (5)
// End velocity for this stroke.
#define B_END_VEL (6)
// Maximum velocity for this stroke.
#define B_MAX_VEL (7)
// Both left and right stroke distances.
#define L_BOTH_DIST (8)
// Right stroke distance.
#define W_RIGHT_DIST (8)
// Left stroke distance.
#define W_LEFT_DIST (10)
// Right coordinated countdown value.
#define L_RIGHT_COUNT (12)
// Left coordinated countdown value.
#define L_LEFT_COUNT (16)
// Dominant distance and count.
#define L_DOM (20)
// Total distance for dominant wheel to travel.
#define W_DOM_DIST (20)
// Distance the dominant wheel has traveled.
#define W_DOM_COUNT (22)
#define NONE (0)
#define LEFT (1)
#define RIGHT (2)
#define CENTER (3)
// Used with LEDs, light sensors, line sensors,
#define POWER (4)
// -[ Tone generator ]-
/*  These constants are used to set the voices in the tone player and to form its commands.  */
#define SQU (0)
#define SAW (1)
#define TRI (2)
// Square, sawtooth, triangle, sine.
#define SIN (3)
#define STOP (1)
#define PAUSE (2)
// Tone player immediate commands.
#define PLAY (3)
#define TONE (0)
#define VOLU (1)
#define SYNC (2)
// Tone player sequence commands.
#define PAUS (3)

typedef struct S2T {
  char dummy__;
} S2T;

  int32_t S2T_start_tones( S2T *self );
  int32_t S2T_stop_all( S2T *self );
  int32_t S2T_beep( S2T *self );
  int32_t S2T_command_tone( S2T *self, int32_t cmd_tone);
  int32_t S2T_set_volume( S2T *self, int32_t vol);
  int32_t S2T_set_voices( S2T *self, int32_t v1, int32_t v2);
  int32_t S2T_play_sync( S2T *self, int32_t value);
  int32_t S2T_play_pause( S2T *self, int32_t value);
  int32_t S2T_get_sync( S2T *self );
  int32_t S2T_wait_sync( S2T *self, int32_t value);
  int32_t S2T_play_tone( S2T *self, int32_t time, int32_t frq1, int32_t frq2);
  int32_t S2T_play_tones( S2T *self, int32_t addr);
  int32_t S2T_start_timer( S2T *self, int32_t number);
  int32_t S2T_get_timer( S2T *self, int32_t number);
  int32_t S2T_delay_tenths( S2T *self, int32_t time);
#endif
